using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace airs
{
    public class airs
    {
        public static void Main()
        {
            		CategoryBuilder.Create("Airsoft", "contains all airsoft equipment", ModAPI.LoadSprite("icon.png"));

            ModAPI.Register(
new Modification()
{
    NameOverride = "Airsoft Pellet",
    NameToOrderByOverride = "!",
    DescriptionOverride = "fjfnbfgdfdgfgd",
    OriginalItem = ModAPI.FindSpawnable("Stick"),
    CategoryOverride = ModAPI.FindCategory(" "),
    ThumbnailOverride = ModAPI.LoadSprite("pellet.png"),
    AfterSpawn = (Instance) =>
    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pellet.png");


        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(ColliderBoxDeleteVar);
        }
        Instance.FixColliders();

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Snow");

        phys.Properties = prop;

    }
}
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Game Face GF529",
                    DescriptionOverride = "An airsoft sniper",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("gamef.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gamef.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("s.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Airsoft Pellet");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1.3f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.FixColliders();

    }
}
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "JAG Arms Scattergun BFG Gas",
                    DescriptionOverride = "An airsoft shotgun",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("jag.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("jag.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("s.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Airsoft Pellet");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1.3f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.FixColliders();

    }
}
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Firepower Chief .45 Airsoft Pistol",
                    DescriptionOverride = "An airsoft pistol",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("cheif.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cheif.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("s.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Airsoft Pellet");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.FixColliders();

    }
}
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Colt M4 CQB",
                    DescriptionOverride = "An airsoft rifle",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("colt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colt.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("s.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Airsoft Pellet");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1.2f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.FixColliders();

    }
}
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Glock 17 Gen 4",
                    DescriptionOverride = "An airsoft pistol",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("glock.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("glock.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("s.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Airsoft Pellet");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.FixColliders();

    }
}
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "AE Max Grape Ape",
                    DescriptionOverride = "An airsoft pistol",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("grape.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("grape.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("s.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Airsoft Pellet");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.FixColliders();

    }
}
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Airsoft Mask",
                    DescriptionOverride = "An airsoft mask",
                    CategoryOverride = ModAPI.FindCategory("Airsoft"),
                    ThumbnailOverride = ModAPI.LoadSprite("mask.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mask.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0.065f, 0.065f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "mask.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
        }
    }
}